const system = require("../../../system");
const ServiceBase = require("../../sve.base")

/**
 * 订单产品表
 */
class OorderService extends ServiceBase {
  constructor() {
    super("order", ServiceBase.getDaoName(OorderService));

    this.oorderinforegDao = system.getObject("db.order.oorderinforegDao");
    this.oorderdeliverDao = system.getObject("db.order.oorderdeliverDao");
    this.oorderprocessDao = system.getObject("db.order.oorderprocessDao");

    this.osourceDao = system.getObject("db.common.osourceDao");

    this.oproductDao = system.getObject("db.product.oproductDao");
    this.oprocessDao = system.getObject("db.product.oprocessDao");
    this.oproductprocessDao = system.getObject("db.product.oproductprocessDao");
  }

  /**
   *  新增渠道订单
   * @returns {Promise<void>}
   */
  async addSourceOrder(params) {
    // 整理参数
    let order = {
      merchantId: "",
      channelOrderNo: "",
      busi_type: 1,
      busi_id: "",
      price: 0,
    };
    order.productId = Number(params.productId);
    order.sourceId = Number(params.sourceId);
    order.sourceNo = this.trim(params.sourceNo);
    order.notes = this.trim(params.notes);
    order.contactMobile = this.trim(params.contactMobile);

    // 验证来源
    let source = await this.osourceDao.findById(order.sourceId);
    if (!source) {
      return system.getResult(null, "来源错误");
    }

    // 验证产品
    let product = await this.oproductDao.findById(order.productId);
    if (!product) {
      return system.getResult(null, "产品错误");
    }

    // 获取产品状态
    await this.getProductProcessList(productId, );

    // 查询产品订单状态

    // 合并订单状态

    // 开启事务

    // 插入订单数据

    // 插入订单状态数据
  }

  /**
   * 新建进度
   * @param params
   * @returns {Promise<void>}
   */
  async createProcess(params) {
    // 整理参数 变成这个格式，id, status, params

    // 查询订单

    // 找出订单下个状态，于参数订单状态匹配

    // 调用状态func(order, nextObj, params)
  }

  /**
   * 构建产品流程对象
   * @param productPid
   * @param chooseProductIds
   * @returns {Promise<void>}
   */
  async getProductProcessList(productPid, chooseProductIds) {
    // 查询所有产品子项
    let productList = await this.oproductDao.findListByPid(productPid);

    // 根据所选产品id, 查询产品流程
    let productIds = [];
    for (let product of productList) {
      // 过滤未选择产品
      if(product.is_choose && chooseProductIds && chooseProductIds.indexOf(product.id) == -1) {
        continue;
      }
      productIds.push(product.id);
    }
    if (productIds.length == 0) {
      return null;
    }

    // 查询产品流程
    let processMap = await this.oproductprocessDao.findMapByProductProductIds(productPid, productIds);
    let orderProcessList = [];

    for (let productId of productIds) {
      let currentProcess = processMap[productId];
      let orderProcess = {};
      if (processList.length > 0) {
        let lastProcess = productList[processList.length - 1];
      }
    }

  }
}

module.exports = OorderService;